/*******************************************************************
*******  Copyright (c)            Alexandros V. Gerbessiotis       *
******* All rights reserved; read copyag.txt file                  *
*******************************************************************/
/**** MPI related definitions */
#include <mpi.h>
#define AIBEGIN(X)         ( MPI_Init(&argc,&argv), mpi_basetime=MPI_Wtime() )
#define AIEND()            ( MPI_Barrier(MPI_COMM_WORLD),MPI_Finalize() )
#define AIABORT(X)         ( MPI_Abort(MPI_COMM_WORLD, __LINE__ ) )
#define AIBSPINIT(X,Y,Z)   {;}
#define AIPID()            ((mpi_pid==-1)?(MPI_Comm_rank(MPI_COMM_WORLD,\
                                       &mpi_pid),mpi_pid):mpi_pid)
#define AINPROCS()         ((mpi_nprocs==-1)?(MPI_Comm_size(MPI_COMM_WORLD,\
                                       &mpi_nprocs),mpi_nprocs):mpi_nprocs)    
#define AITIME()           (MPI_Wtime()-mpi_basetime)

#define AIPUT(X,Y,Z,W,R)   MPI_Put( (char *)(Y), (R), MPI_CHAR, (X),\
                                            (W), (R), MPI_CHAR, win )
#define AIGET(X,Y,W,Z,R)   MPI_Get( (char *)(Z), (R), MPI_CHAR, (X),\
                                            (W), (R), MPI_CHAR, win )
#define AIHPPUT(X,Y,Z,W,R) MPI_Put( (char *)(Y), (R), MPI_CHAR, (X),\
                                            (W), (R), MPI_CHAR, win )
#define AIHPGET(X,Y,W,Z,R) MPI_Get( (char *)(Z), (R), MPI_CHAR, (X),\
                                            (W), (R), MPI_CHAR, win )
#define AIREGISTER(X,Y)    MPI_Win_create( (char *)(X),    (Y),   1,\
                                   MPI_INFO_NULL,MPI_COMM_WORLD,&win)  
#define AIDEREGISTER(X)    MPI_Win_free(&win)  
#define AICOMMIT()	   {;}
#define AICOMSTART()       MPI_Win_fence(0,win)
#define AICOMEND()         MPI_Win_fence(0,win)
#define AIBARRIER()        MPI_Barrier(MPI_COMM_WORLD)
#define AISYNC()            MPI_Win_fence(0,win),MPI_Barrier(MPI_COMM_WORLD) 

#define AIMPUT(X,Y,Z,W,R)  MPI_Put( (char *)(Y), (R), MPI_CHAR, (X),\
                                            (W), (R), MPI_CHAR,\
                                        aiwin[aisearch((void *)Z)])
#define AIMGET(X,Y,W,Z,R)  MPI_Get( (char *)(Z), (R), MPI_CHAR, (X),\
                                            (W), (R), MPI_CHAR,\
                                        aiwin[aisearch((void *)Y)])
#define AIMHPPUT(X,Y,Z,W,R) MPI_Put((char *)(Y), (R), MPI_CHAR,  (X),\
                                            (W), (R), MPI_CHAR,\
                                        aiwin[aisearch((void *)Z)]) 
#define AIMHPGET(X,Y,W,Z,R) MPI_Get((char *)(Z), (R), MPI_CHAR,  (X),\
                                            (W), (R), MPI_CHAR,\
                                        aiwin[aisearch((void *)Y)])
 /* Potential alternative precede AIO with MPI_Win_fence(0,aiwin[aisearch((void *)Y)]), */
#define AIMREGISTER(X,Y)   MPI_Win_create( (char *)(X),    (Y),   1,\
                                   MPI_INFO_NULL,MPI_COMM_WORLD,\
                                        &aiwin[aiinsert((void*)X)]) 
#define AIMDEREGISTER(X)   MPI_Win_free(&aiwin[aidelete(X)])
#define AIMCOMMIT()	   {;}
#define AIMCOMSTART(Z)     MPI_Win_fence(0,aiwin[aisearch((void *)Z)])
#define AIMCOMEND(Z)       MPI_Win_fence(0,aiwin[aisearch((void *)Z)])
#define AIMBARRIER()       MPI_Barrier(MPI_COMM_WORLD)

/*
#define AI1DEREGISTER(X) {aidelete(X);} 
*/

extern MPI_Comm comm;
extern MPI_Win  win;
extern MPI_Win  aiwin[];
extern void*    bspmpi[];
extern int bspmpi_max ;
extern int bspmpi_first;
extern int bspmpicur_max ;
extern int mpi_pid ;
extern int mpi_nprocs ;
extern double mpi_bsp_l ;
extern double mpi_bsp_g ;
extern double mpi_basetime;

int  aisearch (void *);
int  aiinsert (void *);
int  aidelete (void *);
